/****************************************/
/*                                      */
/*             EXAMPLE #1               */
/*                                      */
/*     Algebraic Expression Solver      */
/*                                      */
/*    Copyright 1989, Ryan Software     */
/*                                      */
/****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include "asolver.h"


/****************/
/*              */
/* main program */
/*              */
/****************/

main()
{
char *p;
char *prog;
int i,mode,err;
double answer;

mode = 1;

p=malloc(100);
if(!p)
   {
   printf("Insufficent memory\n");
   exit(0);
   }

/* Process expressions until a blank line is entered */
do {
   prog=p;
   printf("\nEnter expression: ");
   gets(prog);
   err = a_solver(mode,prog,&answer);
   if(err == A_S_NOER)
      {
      printf("Answer = %lf\n",answer);
      }
   else
      {
      if(err != A_S_BLNK) errmsg(err);
      }
   } while(*p);

exit(0);
}

/******************/
/* error messages */
/******************/
errmsg(code)
int code;
{
if(code== A_S_SYNT) printf("Syntax error\n");
if(code== A_S_PARG) printf("Unbalanced parentheses\n");
if(code== A_S_NEXP) printf("No expression present\n");
if(code== A_S_ILLC) printf("Illegal character in expression\n");
if(code== A_S_BLNK) printf("Blank line\n");
if(code== A_S_DIV0) printf("Division by zero\n");
if(code== A_S_LOGA) printf("Logarithm of a negative number\n");
if(code== A_S_FACT) printf("Factorial of a negative number\n");
if(code== A_S_SQRT) printf("Square root of a negative number\n");
exit(-1);

}

