/****************************************/
/*                                      */
/*             EXAMPLE #4               */
/*                                      */
/*     Algebraic Expression Solver      */
/*                                      */
/*    Copyright 1989, Ryan Software     */
/*                                      */
/****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include "asolver.h"

FILE *handle, *fopen();

/****************/
/*              */
/* main program */
/*              */
/****************/

main(argc,argv)
int argc;
char *argv[];
{
char *parse_line();
char input_file[16];
char *p;
char *prog,*equation;
int i,mode,err;
double answer;
bool DISPLAY = FALSE;
mode = 1;

p=malloc(100);
if(!p)
   {
   printf("Insufficent memory\n");
   exit(0);
   }


if(argc>1)
   {
   prog = p;
   strcpy(input_file,argv[1]);
   handle = fopen(input_file,"r");
   while(fget_line(handle,prog) != EOF)
      {
      if(strnicmp(prog,"rem:",4) == 0)
         {
         /* it is a remark so do nothing */
         }
      else if(strnicmp(prog,"comment:",8) == 0)
         {
         /* it is a comment print it */
         printf("%s\n",parse_line(prog));
         }
      else
         {
         err = a_solver(mode,prog,&answer);
         if(err == A_S_NOER)
            {
            printf("%lf\n",answer);
            }
         if(err != A_S_BLNK && err != A_S_NOER)
            {
            errmsg(err);
            }
         }
      prog = p;
      }
   }

exit(0);
}
/******************/
/* error messages */
/******************/
errmsg(code)
int code;
{
if(code== A_S_SYNT) printf("Syntax error\n");
if(code== A_S_PARG) printf("Unbalanced parentheses\n");
if(code== A_S_NEXP) printf("No expression present\n");
if(code== A_S_ILLC) printf("Illegal character in expression\n");
if(code== A_S_BLNK) printf("Blank line\n");
if(code== A_S_DIV0) printf("Division by zero\n");
if(code== A_S_LOGA) printf("Logarithm of a negative number\n");
if(code== A_S_FACT) printf("Factorial of a negative number\n");
if(code== A_S_SQRT) printf("Square root of a negative number\n");
exit(-1);

}
/*************************************/
/* parse the line to get the options */
/*************************************/
char *parse_line(prog)
char *prog;
{
char *line;
while(*prog != ':') *prog++;
*prog++;
return(prog);
}
